/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.exporter.test;

import java.util.Collection;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.backup.ImportExportService;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.services.organization.Group;
import org.exoplatform.services.organization.Membership;
import org.exoplatform.services.organization.MembershipType;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.organization.User;
import org.exoplatform.test.BasicTestCase;
/**
 * Thu, May 15, 2004    
 * @author: Tuan Nguyen
 * @version: $Id: TestExportService.java,v 1.7 2004/07/24 16:38:59 tuan08 Exp $
 * @since: 0.0
 * @email: tuan08@yahoo.com
 */
public class TestImportV1Service extends BasicTestCase {
	
  private static ImportExportService service_ ;
	private static  OrganizationService orgService_ ;
  
  boolean test = false;
	
  public TestImportV1Service(String name) {
    super(name);
  }

  public void setUp() throws Exception {
    if( !test) return;
    PortalContainer manager  = PortalContainer.getInstance();
    service_ = (ImportExportService) manager.getComponentInstanceOfType(ImportExportService.class) ;
    orgService_ = (OrganizationService) manager.getComponentInstanceOfType(OrganizationService.class);    
  }

  public void tearDown() throws Exception {   
    if( !test) return;
  	PortalContainer manager  = PortalContainer.getInstance();
  	HibernateService hservice = 
  		(HibernateService) manager.getComponentInstanceOfType(HibernateService.class) ;
  	hservice.closeSession();
  }   
  public void testImportData() throws Exception {  
    if( !test) return;
    Group group = orgService_.getGroupHandler().findGroupById( "/users");    
    assertEquals( group.getGroupName(), "users");  
    
//    service_.setDirectory( "D:\\test\\serviceV1");
    service_.importServiceData() ;
    System.err.println(service_.getImportLogger().getTextSummary()) ;
    
    group = orgService_.getGroupHandler().findGroupById( "/admin");    
    assertEquals( group.getGroupName(), "admin");  
    
    group = orgService_.getGroupHandler().findGroupById( "/portal/share");
    assertEquals( group.getGroupName(), "share");  
//    System.out.println("\n\n======================>"+group.getGroupName()+"\n\n");
//    Collection collection = orgService_.getGroupHandler().findGroups(  null);
//    System.out.println("\n======================>"+collection.size()+"\n");
//    for( Object ele : collection)    
//      System.out.println("======================>"+ ((Group)ele).getGroupName());
    
    MembershipType mt = 
      orgService_.getMembershipTypeHandler().findMembershipType( "member");
    assertEquals("Expect mebershiptype is:", "member", mt.getName());  
    
//    service_.setDirectory( "D:\\test\\serviceV2");
    service_.exportServiceData() ;
    
    
//    service_.setDirectory( "D:\\test\\serviceV1");
    service_.importUserData();
    System.err.println(service_.getImportLogger().getTextSummary()) ;
    
    User u = orgService_.getUserHandler().findUserByName( "portal");   
    System.out.println( "thuan moi import "+ u.getFullName());
    assertTrue("Found user instance", u != null);
    
    Collection collection = orgService_.getMembershipHandler().findMembershipsByUser( "admin");
    for( Object ele : collection){
      System.out.println("================>Memberships : "
          +((Membership)ele).getGroupId()+" | "
          +((Membership)ele).getUserName()+" | "+((Membership)ele).getMembershipType());
    }
  }
  
}