/**
 * Copyright 2001-2003 The eXo platform SARL All rights reserved.
 * Please look at license.txt in info directory for more license detail. 
 */

package org.exoplatform.services.remote.group.test;

import java.util.List;
import org.exoplatform.container.PortalContainer; 
import org.exoplatform.container.configuration.ConfigurationManager;
import org.exoplatform.container.xml.Component;
import org.exoplatform.container.xml.InitParams;
import org.exoplatform.services.remote.group.*;
import org.exoplatform.services.remote.group.impl.*;
import org.exoplatform.services.remote.group.impl.GetCommunicationMonitorHandler;
import org.exoplatform.test.BasicTestCase;

/**
 * Created y the eXo platform team
 * User: Benjamin Mestrallet
 * Date: 16 juin 2004
 */
public class TestCommunicationService extends BasicTestCase {

  public TestCommunicationService(String name) {
    super(name);
  }

  public void setUp() throws Exception {
   
  }

  public void testInitCommunicationService() throws Exception {
    PortalContainer pcontainer = PortalContainer.getInstance() ;
    CommunicationServiceImpl service1 = 
      (CommunicationServiceImpl)pcontainer.
                                getComponentInstanceOfType(CommunicationService.class) ;
    
    ConfigurationManager manager = 
      (ConfigurationManager) pcontainer.getComponentInstanceOfType(ConfigurationManager.class);
    Component component =  manager.getComponent(CommunicationService.class) ;
    InitParams params = null ;
    if(component != null) params = component.getInitParams() ;
    
    CommunicationServiceImpl service2 = 
      (CommunicationServiceImpl)pcontainer.createComponent(CommunicationServiceImpl.class, params);
    service2.addPlugin(new PingMessageHandler()) ;
    service2.addPlugin(new GetCommunicationMonitorHandler()) ;
    
    CommunicationServiceImpl service3 = 
      (CommunicationServiceImpl)pcontainer.createComponent(CommunicationServiceImpl.class, params);
    service3.addPlugin(new PingMessageHandler()) ;
    service3.addPlugin(new GetCommunicationMonitorHandler()) ;
    
    Thread.sleep(1000) ;
    System.out.println(service3.getInfo()) ;
    
    List results = service3.pingAll("ping") ;
    for(int i = 0 ; i < results.size() ; i++) {
      PingResult result = (PingResult) results.get(i);
      System.out.println("Result from sender: " + result.getMemberInfo().getIpAddress()) ;
      System.out.println("    Reply Message" + result.getReplyMessage()) ;
    }
    
    List members = service1.getMembersInfo() ;
    for(int i = 0 ; i < members.size() ; i++) {
      MemberInfo member = (MemberInfo)members.get(i) ;
      CommunicationServiceMonitor monitor = service1.getCommunicationServiceMonitor(member) ;
      System.out.println("Find monitor of the host: " + monitor.getMemberInfo()) ;
    }
    service3 = null ;
    System.out.println(service1.getInfo()) ;
  }
}