package org.exoplatform.velocity.directive;

import java.io.IOException;
import java.io.Writer;
import javax.faces.context.FacesContext;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;
import org.exoplatform.faces.core.component.UIExoComponent;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since March 3, 2005
 * @version $Id$
 */
public class JSFRenderChild extends Directive {
  public String getName()  {    return "jsfRenderChild"; }        
  
  public int getType() {  return LINE; }        
  
  public void init(RuntimeServices rs, InternalContextAdapter context, Node node) throws Exception {
    super.init(rs, context, node);
  }
  
  public boolean render(InternalContextAdapter context,  Writer w, Node node)
  throws IOException,  MethodInvocationException, ResourceNotFoundException, ParseErrorException {        
    String  componentId = (String)node.jjtGetChild(0).value(context);
    UIExoComponent component = (UIExoComponent)context.get(UIExoComponent.UICOMPONENT) ;
    UIExoComponent child = component.findComponentById(componentId) ;
    if(child != null) {
      FacesContext facescontext = FacesContext.getCurrentInstance() ;
      child.encodeBegin(facescontext) ;
      child.encodeChildren(facescontext) ;
      child.encodeEnd(facescontext) ;
    } else {
      w.write("#jsfRenderChild( Unknow Child Id: " +  componentId + ")" ) ;
    }
    return true;
  }
}