/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.session;

import java.util.Locale;
import java.util.ResourceBundle;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.resources.LocaleConfig;
import org.exoplatform.services.resources.LocaleConfigService;
import org.exoplatform.services.resources.ResourceBundleService;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Jan 11, 2005
 * @version $Id$
 */
public class PortalResources  {
  private ResourceBundle portalResource_ ;
  private ResourceBundle portalOwnerResource_ ;
  private LocaleConfig localeConfig_ ;
  
  public PortalResources() {
    
  }
  
  public void changeLocaleConfig(String localeStr, String owner) {
    LocaleConfigService manager = 
      (LocaleConfigService)PortalContainer.getComponent(LocaleConfigService.class) ;
    localeConfig_ = manager.getLocaleConfig(localeStr);
    Locale locale =  localeConfig_.getLocale() ;
    ResourceBundleService service = 
      (ResourceBundleService)PortalContainer.getComponent(ResourceBundleService.class) ;
    portalResource_ = 
      service.getResourceBundle( service.getSharedResourceBundleNames(), locale) ;
    portalOwnerResource_ = localeConfig_.getOwnerResourceBundle(owner) ;
    
    try {
      portalOwnerResource_ = 
        service.getResourceBundle("locale.users." + owner, localeConfig_.getLocale()) ;
      if(portalOwnerResource_ == null ) {
        portalOwnerResource_ = service.getResourceBundle("locale.users.default", locale) ;
      }
    } catch (Exception ex) {
      ex.printStackTrace() ;
    }
  }
  
  public LocaleConfig getLocaleConfig() { return localeConfig_ ; }
  
  public Locale getLocale() { return localeConfig_.getLocale() ; }
  
  public ResourceBundle getPortalResourceBundle() {  return portalResource_ ; }
  
  public ResourceBundle getPortalOwnerResourceBundle() { return portalOwnerResource_ ; }

  public ResourceBundle getApplicationResource() {  return portalResource_ ; }

  public ResourceBundle getApplicationOwnerResource() { return portalOwnerResource_ ; }
  
  public ResourceBundle getApplicationResource(String name)  {
    return localeConfig_.getResourceBundle(name) ;
  }
  
  public ResourceBundle getApplicationOwnerResource(String owner)  {
    return localeConfig_.getOwnerResourceBundle(owner) ;
  }
}