/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL. All rights reserved.         *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.display.component;

import java.util.Enumeration;
import java.util.List;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequest;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIPortlet;
import org.exoplatform.services.portal.content.DocumentContent;
import org.exoplatform.services.portal.content.PortalContentService;


/**
 * @author benjaminmestrallet
 */
public class UIContentPortlet extends UIPortlet {
  
  final static public String[] DEFAULT_VALUES = {"id=" };
  final static public String ENCODING = "UTF-8" ;
  
  private PortalContentService contentService_ ;
  
  public UIContentPortlet() throws Exception {
    contentService_ =(PortalContentService) PortalContainer.getComponent(PortalContentService.class) ;
    setClazz("UIContentPortlet");
    setRendererType("ChildrenRenderer");
    ExternalContext eContext = FacesContext.getCurrentInstance().getExternalContext();
    PortletRequest request = (PortletRequest) eContext.getRequest();
    PortletPreferences prefs = request.getPreferences();    
    Enumeration e = prefs.getNames();
    List children = getChildren();        
    String id = null ;   
    DocumentContent documentContent = null ;
    while (e.hasMoreElements()) {
      String name = (String) e.nextElement();       
      String[] values = prefs.getValues(name, DEFAULT_VALUES);      
      try {        
        id = values[0].split("=")[1] ;
      }catch (Exception ex) {}                
    }    
    if(id != null) {          	
      documentContent = contentService_.getDocumentById(id) ;  
    }
    UIContentDisplay uiContentDisplay = new UIContentDisplay(documentContent) ;
    uiContentDisplay.setId("id" + Integer.toString(uiContentDisplay.hashCode())) ;
    uiContentDisplay.setRendered(true) ;        
    children.add(uiContentDisplay);                          
  }  
}