/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.component;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;


import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.faces.core.component.UIPageListIterator;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.event.CheckRoleInterceptor;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.event.UIComponentObserver;
import org.exoplatform.portlets.user.component.UIListUser.DeleteUserActionListener;
import org.exoplatform.services.organization.Group;
import org.exoplatform.services.organization.Membership;
import org.exoplatform.services.organization.OrganizationService;
import org.exoplatform.services.organization.User;


/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIViewUserInGroup.java,v 1.1 2004/10/22 14:23:30 tuan08 Exp $
 */
public class UIViewUserInGroup extends UIGrid {  
  
	UIPageListIterator uiPageIterator_ ;
  UIMembershipForm uiMembershipForm_ ;
  private OrganizationService service_ ;
  private String groupId_ ;
  private HashMap memberShipType_ ;
	static Parameter[] DELETE =  { new Parameter(ACTION , DELETE_ACTION) } ;
	public UIViewUserInGroup(OrganizationService service) throws Exception {
    setRendererType("VelocityRenderer") ;
    uiMembershipForm_ = new UIMembershipForm() ;
    uiMembershipForm_.setRendered(false);
    uiMembershipForm_.setId("UIMembershipFormForGroup") ;
		uiPageIterator_ = new UIPageListIterator(new PageListDataHandler()) ;
    service_ = service ;
    memberShipType_ = null ;
    getChildren().add(uiPageIterator_) ;
    getChildren().add(uiMembershipForm_) ;
    addActionListener(DeleteUserActionListener.class, DELETE_ACTION) ;    
	}
  
  public Parameter[] getDeleteParams() { return DELETE; };
  
  public Collection getListUserInGroup() throws Exception {
    memberShipType_ = new HashMap() ;
    if(groupId_ != null) {
      Iterator it = uiPageIterator_.getPageListDataHandler().getDatas().iterator() ;
      while(it.hasNext()){
        User user = (User)it.next() ;
        String type = getMemberShips(user.getUserName()) ;
        memberShipType_.put(user.getUserName(), type) ;        
      } 
    }    
    return uiPageIterator_.getPageListDataHandler().getDatas() ;
  }
  public String getUserMemberShipsType(String userName) {
    if( memberShipType_ != null) {
      return memberShipType_.get(userName).toString() ;
    }
    return "" ;    
  }
  private String getMemberShips(String userName) throws Exception{
    String mType = "" ;    
    Collection mt = service_.getMembershipHandler().findMembershipsByUserAndGroup(userName, groupId_) ;
    Iterator it = mt.iterator() ;
    while(it.hasNext()){
      Membership type = (Membership)it.next() ;
      mType = mType + type.getMembershipType() ;
      if(it.hasNext()) mType = mType + ", " ;
    }
    return mType ;
  }
  public void registerComponentObserver(UIExoComponent parent)  {
	  UIGroupExplorer uiExplorer = 
      (UIGroupExplorer) parent.getAncestorOfType(UIGroupExplorer.class) ;
    uiExplorer.addObserver(new GroupChangeObserver());
	}
	
  public void update() throws Exception { 
    UIGroupExplorer uiExplorer = 
      (UIGroupExplorer) getAncestorOfType(UIGroupExplorer.class) ;
    uiPageIterator_.setPageList(uiExplorer.getMemberOfTheCurrentGroup()) ;
    Group group  = uiExplorer.getCurrentGroup();
    groupId_ = group.getId();    
  }
  
	public class GroupChangeObserver extends UIComponentObserver {
	  public void onChange(UIExoComponent target) throws Exception  {
	    UIGroupExplorer uiExplorer = (UIGroupExplorer) target ;
      uiPageIterator_.setPageList(uiExplorer.getMemberOfTheCurrentGroup()) ;
      Group group  = uiExplorer.getCurrentGroup();
      if(group == null) {
        uiMembershipForm_.setRendered(false);
      } else {
        groupId_ = group.getId();
        uiMembershipForm_.setRendered(true);
        uiMembershipForm_.populateFormByGroup(group.getId());
      }
	  }
	}
  static public class DeleteUserActionListener extends ExoActionListener  {
    public DeleteUserActionListener() {
      addInterceptor(new CheckRoleInterceptor("admin")) ;  
    }
    
    public void execute(ExoActionEvent event) throws Exception {
      UIViewUserInGroup uiUserInGroup = (UIViewUserInGroup) event.getComponent() ;
      String userName = event.getParameter(OBJECTID) ;
      List memberships = (List)uiUserInGroup.service_.getMembershipHandler().findMembershipsByUserAndGroup(userName, uiUserInGroup.groupId_) ;
      Membership membership;
      for(int i=0; i < memberships.size(); i++){
        membership = (Membership)memberships.get(i) ;
        uiUserInGroup.service_.getMembershipHandler().removeMembership(membership.getId(), true) ;
      }      
      uiUserInGroup.update() ;      
    }
  }
}