/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.portal.test;


import java.util.ArrayList;
import java.util.Collection;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.List;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.services.database.HibernateService;
import org.exoplatform.services.portal.log.UserActivitiesLogService;
import org.exoplatform.services.portal.log.UserLogQuery;
import org.exoplatform.test.BasicTestCase;

/**
 * Thu, May 15, 2003 @   
 * @author: Tuan Nguyen
 * @version: $Id: TestSkinConfigService.java,v 1.7 2004/07/24 16:34:06 tuan08 Exp $
 * @since: 0.0
 * @email: tuan08@yahoo.com
 */
public class TestUserActivitiesLogService  extends BasicTestCase {
  UserActivitiesLogService service_ ;
  UserLogQuery q ;
  List<SelectItem> style ;
  long currentTime ;
  public TestUserActivitiesLogService(String name) {
    super(name);
  }

  public void setUp() throws Exception {
    service_ = (UserActivitiesLogService) PortalContainer.getInstance().
                getComponentInstanceOfType(UserActivitiesLogService.class) ;
    currentTime = System.currentTimeMillis() ;
    q = new UserLogQuery() ;
    q.setMaxmin("") ;
    q.setAccessIp("") ;
    q.setUserName("") ;
    q.setLimit("0") ;
    GregorianCalendar calendar = new GregorianCalendar() ;
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 0) ;
    calendar.set(GregorianCalendar.MINUTE, 0) ;
    calendar.set(GregorianCalendar.SECOND, 0) ;
    calendar.set(GregorianCalendar.MILLISECOND, 0) ;    
    q.setFromDateTime(calendar.getTimeInMillis()) ;    
    calendar.set(GregorianCalendar.HOUR_OF_DAY, 24) ;
    q.setToDateTime(calendar.getTimeInMillis()) ;
    
    style = new ArrayList<SelectItem>() ;
    style.add(new SelectItem("User Name", "userName")) ;
    style.add(new SelectItem("Portal Owner", "portalOwner")) ;        
  }

  public void tearDown() throws Exception {
  }
  
  public void testSave() throws Exception {
    service_.logUserActivites("session1", "userName1", "admin", currentTime, "") ;
    service_.updateLogUserActivities("session1", currentTime + 5500 ) ;
    service_.logUserActivites("session2", "userName2", "exo", currentTime,  "") ;
    Thread.sleep(2000) ;
    
    Collection chartCollection = service_.getUserLogChartDatas(q, style) ;
    assertEquals("expect collection of chart is", 2, chartCollection.size()) ;
     
    Iterator<List> iter = chartCollection.iterator() ;
    // Group by userName
    List dataList = iter.next() ;
    assertEquals("expect mydata list size is", 2, dataList.size()) ;
    
    Object[] row0 = (Object[])dataList.get(0);
    assertEquals("expect mydata1 session1 name1 is", "userName1", /*name*/row0[0].toString()) ;
    assertEquals("expect session1 counter is", 2, /*count*/Long.parseLong(row0[1].toString())) ;
    assertEquals("expect session1 duration time is", 5500,/*duration*/Long.parseLong(row0[2].toString())) ;
    
    Object[] row1 = (Object[])dataList.get(1);
    assertEquals("expect mydata1 session1 name1 is", "userName2", /*name*/row1[0].toString()) ;
    assertEquals("expect session1 counter is", 1, /*count*/Long.parseLong(row1[1].toString())) ;
    assertEquals("expect session1 duration time is", 0,/*duration*/Long.parseLong(row1[2].toString())) ;
    
    resetHibernateSession() ;
    
    service_.updateLogUserActivities("session2", currentTime + 6500) ;
    service_.logUserActivites("session3", "userName3", "test", currentTime, "") ;
    
    Thread.sleep(2000) ;
    
    chartCollection = service_.getUserLogChartDatas(q, style) ;
    assertEquals("expect collection of chart is", 2, chartCollection.size()) ;
    Iterator<List> it1 = chartCollection.iterator() ;
    
    List nextlist = it1.next() ;
    assertEquals("expect mydata list size is", 3, nextlist.size()) ;
    
    row0 = (Object[])nextlist.get(0);
    assertEquals("expect mydata1 session1 name1 is", "userName1", /*name*/row0[0].toString()) ;
    assertEquals("expect session1 duration time is", 5500,/*duration*/Long.parseLong(row0[2].toString())) ;
        
    row1 = (Object[])nextlist.get(1);
    assertEquals("expect mydata1 session2 name1 is", "userName2", /*name*/row1[0].toString()) ;
    assertEquals("expect session1 duration time is", 6500,/*duration*/Long.parseLong(row1[2].toString())) ;
        
    Object[] row2 = (Object[])nextlist.get(2);
    assertEquals("expect mydata1 session2 name2 is", "userName3", /*name*/row2[0].toString()) ;
    assertEquals("expect session1 duration time is", 0,/*duration*/Long.parseLong(row2[2].toString())) ;
  }
  
  public void testGetUserLogDatas() throws Exception {
    List list = service_.getUserLogDatas(q).getAll() ;
    assertEquals("expect data in DB is ", 3, list.size()) ;
  }
  private  void  resetHibernateSession() {
    PortalContainer pcontainer = PortalContainer.getInstance() ;
    List<HibernateService> list = 
      pcontainer.getComponentInstancesOfType(HibernateService.class) ; 
    for(HibernateService hservice : list) hservice.closeSession() ;
    PortalContainer.setInstance(null) ;  
  }  
}