/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web;

import java.util.ArrayList;
import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.exoplatform.test.web.unit.ClickLinkWithText;
import org.exoplatform.test.web.unit.WebUnit;
/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: WebUnitSuite.java,v 1.1 2004/10/11 23:36:04 tuan08 Exp $
 **/
public class WebUnitSuite {
  
  final static public int NOT_RUN_STATUS = 0 ;
  final static public int OK_STATUS = 1 ;
  final static public int ERROR_STATUS = 2 ;
  final static public int IGNORE_STATUS = 3 ;
    
  private List<WebUnit> units_ ;
  private String name_ ;
  private String description_ ;
  private int status_ = NOT_RUN_STATUS ;
  
  public WebUnitSuite() {
  }
  
  public WebUnitSuite(String name, String description) {
    name_ = name ;
    description_ = description ;
    units_ = new ArrayList<WebUnit>() ;    
  }
  
  public int  getStatus() { return status_ ; }
  public void setStatus(int status) { status_ = status ; }
  
  public List getRequiredSuites() { return null ; }
  
  public void goToPage(String path) {
  	String[] links = StringUtils.split(path, "/") ;
  	for(int i = 0; i < links.length; i++) {
  		addWebUnit(new ClickLinkWithText("GoTo:" + links[i], "Go to " + links[i] + "page").
  				       setTextLink(links[i])) ;
  	}
  }
  
  public String getName() { return name_ ; }
  public String getDescription() { return description_ ; }
  
  public List<WebUnit> getWebUnits() { return units_ ; }

  protected void addWebUnit(WebUnit unit)  {
    units_.add(unit) ;
  }
  
  protected void add(WebUnit unit)  {
    units_.add(unit) ;
  }
  
  protected void addWebSuite(WebUnitSuite suite)  {
	  for(WebUnit unit : suite.getWebUnits()){
		  units_.add(unit) ;
	  }    
  }
  
  public void reset() {
    if(getStatus() == WebUnitSuite.IGNORE_STATUS) return ;
    status_ = NOT_RUN_STATUS ;
    for(int i = 0; i < units_.size() ; i++) {
      WebUnit unit = units_.get(i) ;
      unit.reset() ;
    }
  }
  
  public WebUnit findWebUnit(int id) {
    for(WebUnit unit : units_) {
      if(id == unit.hashCode()) return unit ;
    }
    return null ;
  }
}
