/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.servlet;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
abstract public class  Configuration {
  private Map<String,ActionHandler> handlers_ = new HashMap<String, ActionHandler>(); 
  private WebappGroovyResourceManager tmanager_ ;
  
  public void addDefaultActionHandler(ActionHandler handler) {
    addActionHandler("default", handler) ;
  }
  
  public WebappGroovyResourceManager getResourceManager() { return tmanager_ ; }
  public void setResourceManager(WebappGroovyResourceManager manager) {
    tmanager_ = manager ;
  }
  
  public void addActionHandler(String action, ActionHandler handler) {
    handler.init(this) ;
    handlers_.put(action, handler) ;
  }
  
  public ActionHandler getActionHandler(String action) {
    ActionHandler handler = handlers_.get(action) ;
    if(handler == null) handler = handlers_.get("default") ;
    return handler ;
  }
  
  abstract public void configure(ControllerServlet servlet) throws Exception   ;
}
