/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package control;

import java.util.* ;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.test.web.* ;
import org.exoplatform.test.web.servlet.* ;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class SelectTest extends ActionHandler { 
  private Map availableTests_ ;
  private List categories = new ArrayList() ;
  
  public SelectTest() {
    availableTests_ = new HashMap() ;
      
    TestCategoryDescription category = new TestCategoryDescription("Runner") ;    
    category.addSuite(new TestSuiteDescription("suites.runner.PortalAdminSuites", "Portal Admin's Suites")) ;
    category.addSuite(new TestSuiteDescription("suites.runner.PortalSuites", "Portal Suites")) ;
    category.addSuite(new TestSuiteDescription("suites.runner.PortalUserSuites", "Portal User's Suites")) ;
    category.addSuite(new TestSuiteDescription("suites.runner.ECMPortalAdminSuites", "ECM Admin's Suites")) ;
    category.addSuite(new TestSuiteDescription("suites.runner.ECMPortalSuites", "ECM Portal Suites")) ;
    category.addSuite(new TestSuiteDescription("suites.runner.ECMPortalUserSuites", "ECM User's Suites")) ;
    categories.add(category) ;
    
    category = new TestCategoryDescription("CheckAllPage") ;    
    category.addSuite(new TestSuiteDescription("suites.web.CheckAllLinkSuite", "Check All Admins's Pages")) ;    
    categories.add(category) ;
    
    category = new TestCategoryDescription("Organization") ;
    category.addSuite(new TestSuiteDescription("suites.user.OrganizationPortletSuite", "Organization Managemement")) ;
    category.addSuite(new TestSuiteDescription("suites.user.GroupManagementSuite", "Group Management")) ;
    category.addSuite(new TestSuiteDescription("suites.user.UsersManagementSuite", "User Management")) ;
    category.addSuite(new TestSuiteDescription("suites.user.MembershipManagementSuite", "Membership Management")) ;    
    category.addSuite(new TestSuiteDescription("suites.admin.PortalAdminSuite", "Portal Administration ")) ;        
    categories.add(category) ;
    
    category = new TestCategoryDescription("ECM Portlet") ;
    //Admin
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminTheECMSuite", "ADMIN THE ECM SUITES")) ;    
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminCheckTabsSuite", "Admin Check tabs Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminTemplatesSuite", "Admin Templates Suite")) ;    
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminScriptsSuite", "Admin Scripts Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminRulesSuite", "Admin Rules Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminActionTypesSuite", "Admin Action Types Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminNodeTypesSuite", "Admin Node Types Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.admin.AdminViewSuite", "Admin View Suite")) ;
    //User    
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserECMFileExplorerSuite", "USER ECM FILE EXPLORER SUITES")) ;    
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserAddFolderSuite", "User Add Folder Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserAddDocumentSuite", "User Add Document Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserLockCopyPasteCutSuite", "User Lock Copy, Paste And Cut Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserExportNodeSuite", "User Export Node Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserImportNodeSuite", "User Import Node Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserViewPermissionsSuite", "User View Permissions Suite")) ;    
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserManageCategoriesSuite", "User Manage Categories Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserManageActionsSuite", "User Manage Actions Suite")) ;    
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserViewReferencesSuite", "User View References Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserManageVersionsSuite", "User Manage Versions Suite")) ;    
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserViewNodePropertiesSuite", "User View Node Properties Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserViewNodeTypesSuite", "User View Node Types Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserUploadSuite", "User Upload Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserPublicationsSuite", "User Publications Suite")) ;
    category.addSuite(new TestSuiteDescription("suites.ecm.user.UserSearchSuite", "User Search Suite")) ;
    categories.add(category) ;
   
    category = new TestCategoryDescription("Workflow Portlets") ;
    category.addSuite(new TestSuiteDescription("suites.workflow.WorkflowPortletAdminSuite", "Workflow Administration")) ;
    category.addSuite(new TestSuiteDescription("suites.workflow.WorkflowPortletUserSuite", "User  Workflow ")) ;    
    categories.add(category) ;
    
    category = new TestCategoryDescription("Portal") ;
    category.addSuite(new TestSuiteDescription("suites.admin.PortletRegistrySuite", "Portlet Registration ")) ;
    category.addSuite(new TestSuiteDescription("suites.admin.ResourceBundlePortletSuite", "Resource Management")) ;
    category.addSuite(new TestSuiteDescription("suites.admin.ImportExportSuite", "Import/Export ")) ;    
    category.addSuite(new TestSuiteDescription("suites.admin.IndexingPortletAdminSuite", "Portal Indexing ")) ;
    categories.add(category) ;
    
    category = new TestCategoryDescription("JMX Monitoring") ;
    category.addSuite(new TestSuiteDescription("suites.jmx.JMXMonitoringPortletAdminSuite", "JMX Monitoring")) ;      
    categories.add(category) ;
    
    category = new TestCategoryDescription("Forum") ;
    category.addSuite(new TestSuiteDescription("suites.forum.ForumPortletAdminSuite", "Forum Administration")) ;    
    category.addSuite(new TestSuiteDescription("suites.forum.ForumPortletUserSuite", "User Forum")) ;    
    categories.add(category) ;
    
    category = new TestCategoryDescription("Check Account") ;
    category.addSuite(new TestSuiteDescription("suites.account.CheckAccountSuite", "Check Account")) ;        
    categories.add(category) ;
    
    category = new TestCategoryDescription("Portal Customization") ;    
    category.addSuite(new TestSuiteDescription("suites.portal.CustomizationNavigationSuite", "Navigation Customization")) ;
    category.addSuite(new TestSuiteDescription("suites.portal.CustomizationPageSuite", "Page Customization")) ;
    category.addSuite(new TestSuiteDescription("suites.portal.AdminCustomizationPortalSuite", "Admin Portal Customization")) ;
    category.addSuite(new TestSuiteDescription("suites.portal.ExoCustomizationNavSuite", "Exo Navigation Customization")) ;
    categories.add(category) ;
    
  }
  
  public void execute(HttpServletRequest request, HttpServletResponse response) {
    WebappGroovyResourceManager resManager = getResourceManager() ;
    Map  binding =  resManager.createDefaultBinding(request) ;
    String suite = request.getParameter("suite") ;
    if(suite != null) {
      def config = getConfiguration() ;
      def client = config.getWebClient() ;
      def suites = config.getTestSuites(resManager, suite) ;
      client.setSuites(suites) ;
      client.setName(Integer.toString(new Object().hashCode())) ;
      binding.put("suites", suites) ;
      resManager.merge(response.getWriter(), "templates/RunTest.groovy", binding);
    } else {
      binding.put("availableTests", availableTests_) ;
      binding.put("categories", categories) ;
      resManager.merge(response.getWriter(), "templates/SelectTest.groovy", binding);
    }
  }
}

public class TestCategoryDescription {
  private List suites = new ArrayList() ;
  private String description ;
  
  public TestCategoryDescription(String desc) {
    description = desc ;
  }
  
  public String getDescription() { return  description ; }
  public void addSuite(TestSuiteDescription sd) { suites.add(sd) ; }
  public List getSuites() { return suites ; }
}

public class TestSuiteDescription {
  String className ;
  String name ; 
  
  public TestSuiteDescription(String cn, String tn) {
    className = cn ;
    name =  tn ;
  }
  
  public String getClassName() { return className ; }
  
  public String getName() { return name; }
}