/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserECMFileExplorerSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page and test all the basic actions" ;
  static String NAME = "UserECMFileExplorerSuite" ;
  
  public UserECMFileExplorerSuite() {    
    super(NAME, DESC) ;    
    
    //Admin tab
    addWebSuite(new UserManageVersionsSuite()) ;
    //addWebSuite(new UserManageCategoriesSuite()) ;    
    addWebSuite(new UserManageActionsSuite()) ;    
    addWebSuite(new UserExportNodeSuite()) ; 
    addWebSuite(new UserImportNodeSuite()) ; 
    //Info tab
    addWebSuite(new UserViewReferencesSuite()) ; 
    addWebSuite(new UserViewNodeTypesSuite()) ;   
    addWebSuite(new UserViewPermissionsSuite()) ;
    addWebSuite(new UserViewNodePropertiesSuite()) ;
    //Action tab
    addWebSuite(new UserAddDocumentSuite()) ;    
    addWebSuite(new UserLockCopyPasteCutSuite()) ;      
    addWebSuite(new UserUploadSuite()) ;
    
    addWebSuite(new UserSearchSuite()) ;
    //Publish
   // addWebSuite(new UserPublicationsSuite()) ;
  }
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  } 
}