/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserImportNodeSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, select Admin tab, click on UserExportNodeSuite button and test all the basic actions" ;
  static String NAME = "UserImportNodeSuite" ;
  String COMMENT  = "You must run AdminViewSuite before run this suite";
  
  public UserImportNodeSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());
    //-----Select Admin tab
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Admin").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
    ) ;     
    //-----Import Node
    addWebUnit(
      new ClickURLLinkUnit("ClickOnImportNode", "click on Import Node button").
      setURL("&uicomponent=UIToolbar&op=importNode").                  
      addValidator(new ExpectFormIdValidator("importForm"))      
    ) ;     
    //----------Import File Field empty
    addWebUnit(
      new SubmitFormUnit("UploadBlankFilename", "Upload file with blank file name").
      setFormId("importForm").        
      setField("op","save").
      addValidator(new ExpectTextValidator(""))      
    ) ;
    //----------Import File Util.class
    def is;
    is= Thread.currentThread().
        getContextClassLoader().
        getResourceAsStream("org/exoplatform/test/web/Util.class") ;    
    
    addWebUnit(
      new SubmitFormUnit("ImportFileClass", "click on import button").
      setFormId("importForm").   
      setFileField("upload1","Unit.class", is).
      setFileField("upload2","Unit.class", is).
      setFileField("upload3","Unit.class", is).
      setField("op","save").
      addValidator(new ExpectTextValidator("The import is not possible due to invalide serialized data."))     
    ) ;
    //----------Click on Cancel
    addWebUnit(
      new SubmitFormUnit("ClickOnCancel", "click on cancel button").
      setFormId("importForm").
      setField("op","PhaseId[1].cancel").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=Actions"))
    ) ;
    //Back to home
    addWebUnit(
      new ClickURLLinkUnit("ClickOnHome", "back to home").
      setURL("&uicomponent=UIJCRExplorer&op=changeNode&objectId=/").      
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIDocumentInfo&op=saveNode&objectId=cms"))            
    ) ;      
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}