/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserManageCategoriesSuite extends WebUnitSuite {
  static String DESC = "Go to Ecm Portlet User page, click on Info tab, click on Manage Categories button and to do somethings" ;
  static String NAME = "UserManageCategoriesSuite" ;
  String COMMENT  = "You must run AdminViewSuite before run this suite";
  
  public UserManageCategoriesSuite() {    
    super(NAME, DESC) ;    
    addWebSuite(new UserAddFolderSuite());
    //-----Select Admin tab
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTab", "Select Admin tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Admin").             
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
    ) ;   
    //-----Manage Category
    addWebUnit(
      new ClickURLLinkUnit("ClickOnManageCategory", "click on Manage Category button").
      setURL("&uicomponent=UIToolbar&op=manageCategories").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=add"))      
    ) ;   
    //----------Add Category
    addWebUnit(
      new ClickURLLinkUnit("AddCategory", "click on Add Category button").
      setURL("&uicomponent=UICategoriesList&op=add").      
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UITaxonomyList&op=selectTaxonomy&objectId=productionCmsCategoriesCms"))                            
    ) ;                   
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "click select button on node row").
      setURL("&uicomponent=UITaxonomyList&op=selectTaxonomy&objectId=productionCmsCategoriesCms").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/news"))      
    ) ; 
    addWebUnit(
        new ClickURLLinkUnit("SelectNode", "click select button on node row").
        setURL("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/news").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=delete&objectId=/cms/categories/cms/news"))      
    ) ; 
    //-----Delete created Category
    addWebUnit(
      new ClickURLLinkUnit("RemoveCreatedCategory", "delete created category").
      setURL("&uicomponent=UICategoriesList&op=delete&objectId=/cms/categories/cms/news"). 
      addValidator(new ExpectNoTextValidator("/cms/categories/cms/news"))      
    ) ;  
    //Saved Session
    addWebUnit(
      new ClickURLLinkUnit("SavedSession", "click on save Session button").
      setURL("&uicomponent=MainToolbar&op=saveSession").        
      addValidator(new ExpectTextValidator("All the changes have been saved"))      
    ) ;    
    //Back to previous node
    addWebUnit(
      new ClickURLLinkUnit("BackToPreviousNode", "back to previous node").
      setURL("&uicomponent=UICategoriesList&op=PhaseId[1].cancel")      
    ) ;
    //Select Workspace
    addWebUnit(
      new ClickURLLinkUnit("SelectWorkspace", "select Workspace button").
      setURL("&uicomponent=MainToolbar&op=selectWorkspace").                  
      addValidator(new ExpectTextValidator("Workspaces "))      
    ) ;    
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}