alias ls="ls --color"

alias cdhome="cd ~"
alias cdwinhome="cd $USER_HOME"
alias cdback='cd  $OLDPWD'
alias cdv2x="cd $EXO_SRC_CODE"
alias cdexo-platform="cd $EXO_SRC_CODE/exo-platform"
alias cdexo-portal="cd $EXO_SRC_CODE/exo-portal"
alias cdexo-ecm="cd $EXO_SRC_CODE/exo-ecm"
alias cdexo-test="cd $EXO_SRC_CODE/exo-test"
alias cdbasedir="cd $BASE_DIRECTORY"

alias mvnrepoclean="rm -rf $M2_REPO/exo-*"

alias mvnmodulecleaninstall="mvn clean install"
alias mvnmoduledeploy="mvn clean install exo:deploy "
alias mvnmoduledeployall="mvn clean install exo:deploy "


alias mvninstallpluginexo="cd $EXO_SRC_CODE/exo-tools/maven2/plugins/exo && mvn install"

alias mvnv2xclean="cdv2x && mvn -f modules.xml clean"

alias mvnworkingbuild="cdv2x && mvn -f working-modules.xml clean install"

alias mvnportaldeploy="cdv2x &&  mvn -f  product-exo-portal.xml -Dclean deploy"

alias mvnportaltest="cd $EXO_SRC_CODE/exo-test/webunit-suites && mvn exo:execute && cdback"
                    
alias mvnecmdeploy="cdv2x &&  mvn -f  product-exo-ecm.xml -Dclean deploy"
alias mvnecmtest="cd $EXO_SRC_CODE/exo-test/webunit-suites && mvn exo:execute -DexecuteId=ecm  && cdback"

alias mvnldapdeploy="cd $EXO_SRC_CODE/exo-platform/services/ldap/api &&
                     mvnmoduledeploy &&
                     cd ../impl &&
                     mvnmoduledeploy &&
                     cd $EXO_WORKING_DIR/exo-tomcat/webapps/portal/WEB-INF/conf &&
                     cp -fv $EXO_SRC_CODE/exo-platform/services/organization/impl/src/java/conf/portal/ldap-organization-configuration.xml . "

alias svnupdatev2x="mvnv2xclean && svn update"
alias svnModifiedFiles='svn st | grep "^M" '
alias svnConflictFiles='svn st | grep "^C" '

alias vibuild="vi $USER_HOME/build.properties"
alias visetting="vi $USER_HOME/.m2/settings.xml"

alias sql="mysql -t -u dev -pdev dev"

alias ldap=" cd /cygdrive/c/openldap && ./slapd -d 1 "

alias cdtomcat="cd $EXO_WORKING_DIR/exo-tomcat"
alias cdtomcatbin="cd $EXO_WORKING_DIR/exo-tomcat/bin"
alias tomcatClean="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
                   rm -rf ../temp/* &&
                   rm -rf ../work/* &&
                   rm -rf ../logs/* "
   
alias tomcatRun="cd $EXO_WORKING_DIR/exo-tomcat/bin && chmod +x *.sh && ./exo-run.sh "

alias tomcatCleanRun="cd $EXO_WORKING_DIR/exo-tomcat/bin &&
		                  rm -rf ../temp/* &&
                      rm -rf ../work/* &&
                      rm -rf ../logs/*  &&
                      chmod +x *.sh && ./exo-run.sh "

alias tomcatPortalDeployRun="mvnportaldeploy && tomcatRun"

alias tomcatPortalDeployTest="mvnportaldeploy &&
                              cd $EXO_SRC_CODE/exo-test/webunit-suites && 
                              rm -rf ../temp tomcat-log.txt &&
                              mvn cargo:execute"

alias tomcatPortalDeployTestWorking="mvnportaldeploy &&
                                     cd $EXO_SRC_CODE/exo-test/webunit-suites && 
                                     rm -rf ../temp tomcat-log.txt &&
                                     mvn cargo:execute -DexecuteId=working"

alias tomcatECMDeployRun="mvnecmdeploy && tomcatRun"

alias tomcatECMDeployTest="mvnecmdeploy &&
                           cd $EXO_SRC_CODE/exo-test/webunit-suites && 
                           rm -rf ../temp tomcat-log.txt &&
                           mvn cargo:execute -DexecuteId=ecm"

alias tomcatECMDeployTestWorking="mvnecmdeploy &&
                                  cd $EXO_SRC_CODE/exo-test/webunit-suites && 
                                  rm -rf ../temp tomcat-log.txt &&
                                  mvn cargo:execute -DexecuteId=working"

# JOnAS aliases

alias cdjonas="cd $EXO_WORKING_DIR/exo-jonas"

alias mvnjonasportaldeploy="cdv2x &&  mvn -P jonas-server -f  product-exo-portal.xml -Dclean deploy"
alias mvnjonasecmdeploy="cdv2x &&  mvn -P jonas-server -f  product-exo-ecm.xml -Dclean deploy"
alias mvnjonasbideploy="cdv2x &&  mvn -P jonas-server -f  product-exo-bi.xml -Dclean deploy"
alias mvnjonasmoduledeploy="mvn -P jonas-server clean install exo:deploy "

alias jonasStart="cd $EXO_WORKING_DIR/exo-jonas/bin/unix && chmod +x jonas && ./jonas start "
alias jonasCleanStart="cd $EXO_WORKING_DIR/exo-jonas/bin/unix && chmod +x jonas	&& rm -rf  ../temp && rm -rf ../../work/* && rm -rf ../../logs/log* && ./jonas start "
alias jonasStop="cd $EXO_WORKING_DIR/exo-jonas/bin/unix && ./jonas stop "

#Local server  client  synch
alias clientserversyncdoc="rsync -rav --delete $BASE_DIRECTORY/projects/eXo-Data/eXo-Documents $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Documents"
alias clientserversyncdesigns="rsync -rav --delete $BASE_DIRECTORY/projects/eXo-Data/eXo-Designs $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Designs"

alias serverclientsyncdoc="rsync -rav --delete $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Documents $BASE_DIRECTORY/projects/eXo-Data/eXo-Documents"
alias serverclientsyncdesigns="rsync -rav --delete $LOCAL_SERVER_USER@$LOCAL_SERVER_IP:/home/$LOCAL_SERVER_USER/java/projects/eXo-Data/eXo-Documents $BASE_DIRECTORY/projects/eXo-Data/eXo-Documents"
                      
function executionTime() {
	let startTime=0
	let stopTime=0
	let countTime=0

	let startTime=$(date +%s) 
	if [ -z "$@" ]                           # Is parameter #1 zero length?
	then
		echo "Command Parameter is zero length"  # Or no parameter passed !
		return
	else
		echo "Command Parameter  is \"$@\""
	fi

	#sleep 10
	#echo $(date +%S) 

	eval $@

	let stopTime=$(date +%s) 
  let countTime=$stopTime-$startTime
	echo 
	echo -------------------------------------------------------------------------
	echo total time is $countTime s
	echo -------------------------------------------------------------------------

}
